
; Драйвер расширенной арифметики
; обычный, из прошивки ПЗУ 326
; для него есть исходник на Macro-11
; и этот драйвер с ошибками, как и исходник на Macro-11 впрочем
; ═══════════════════════════════════════════════════════════════════════════

FISData$:       .word FISDataEnd$ - FISData$
                .word HD$EIS
                .word 0
; ───────────────────────────────────────────────────────────────────────────
                nop
                br      EXT$FIS
; ───────────────────────────────────────────────────────────────────────────
; эмуляция прерывания по вектору 4

EXT$V4:         mov     @#6, -(SP)      ; в стек PS вектора 4
                bis     #1, (SP)        ; установим там бит С
                mov     @#4, -(SP)      ; в стек адрес вектора 4
                rti                     ; и переходим.
                ; в стеке остались PS/PC выхода из вектора 10.
                ; они будут использоваться при выходе из вектора 4
                ; или, если там стек напрямую инициализируется, то они не нужны
; ───────────────────────────────────────────────────────────────────────────
; точка входа в драйвер расширенной арифметики.
; вход - прерывание по вектору 10

EXT$FIS:        mov     #6, -(SP)       ; тут получается значение стека до возникновения прерывания
                                        ; это нужно, если для передачи параметров FIS использовался SP
                add     SP, (SP)
                mov     R5, -(SP)
                mov     R4, -(SP)
                mov     6(SP), R5       ; берём адрес возврата из прерывания
                mov     -(R5), R4       ; получаем опкод, вызвавший прерывание
                mov     R3, -(SP)
                mov     R2, -(SP)
                mov     R1, -(SP)
                mov     R0, -(SP)
                mov     R4, R0          ; опкод
                mov     R0, R1          ; ещё раз
                cmp     R0, #75000      ; это FIS ?
                bhis    FLOAT$          ; скорее всего да, пойдём проверим
                jmp     EXTAR$          ; нет, может EIS? пойдём проверим
; ───────────────────────────────────────────────────────────────────────────
                add     #6, SP          ; мусор
ERRCM$:         call    RESTR$          ; восстановим регистры
                jmp     EXT$V4          ; и сделаем якобы прерывание по вектору 4

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; установка признаков и восстановление регистров

RSTRS$:         bic     #17, 22(SP)     ; чистим поле признаков в PS возврата из прерывания
                bis     R5, 22(SP)      ; и устанавливаем там свои
; End of function RSTRS$


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; восстановление регистров

RESTR$:         mov     (SP)+, 14(SP)   ; берём адрес возврата из RESTR$ или RSTRS$, и сохраняем его
                                        ; на месте значения 6+SP
                mov     (SP)+, R0       ; восстанавливаем все регистры
                mov     (SP)+, R1
                mov     (SP)+, R2
                mov     (SP)+, R3
                mov     (SP)+, R4
                mov     (SP)+, R5
                return                  ; и выходим из п/п. Теперь в стеке только PC PS
; End of function RESTR$                ; для выхода из прерывания


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; умножение R0:R1 = R3:R4 * R5
; на выходе в R5 нуль

IMUL32:         clr     R1              ; тут накапливается результат
                clr     R0
                ror     R5              ; B.hi >> 1
                br      2$

1$:             asr     R5
2$:             bcs     3$              ; если C==1, то пойдём делать сложение
                bne     4$              ; если C==0, но ещё есть биты, то пойдём просто сдвигать
                br      5$              ; если всё - то выход.

3$:             add     R4, R1          ; R0:R1 += R3:R4
                adc     R0
                add     R3, R0

4$:             asl     R4              ; R3:R4 <<= 1
                rol     R3
                br      1$              ; и повторим

5$:             return                  ; как-то не оптимально. можно 2 слова сэкономить
; End of function IMUL32

; ───────────────────────────────────────────────────────────────────────────

FLOAT$:         cmp     R0, #75040      ; точно FIS ?
                blo     1$        ; да
                jmp     ERRCM$          ; нет - другие не эмулируемые опкоды

1$:             bic     #177747, R0     ; определим тип опкода
                asr     R0              ; номер опкода * 2
                asr     R0
                bic     #177770, R1     ; определим номер используемого регистра
                asl     R1              ; регистр * 2
                add     SP, R1          ; это адрес в стеке, где сохранено значение регистра
                mov     R1, -(SP)       ; и сохраним его в стеке. Туда результат ещё писать надо будет
                mov     (R1), R1        ; достанем значение регистра
                mov     (R1)+, R2       ; B.hi
                mov     (R1)+, R3       ; B.lo
                mov     (R1)+, R4       ; A.hi
                mov     (R1)+, R5       ; A.lo
                mov     R1, -(SP)       ; и снова сохраним
                add     PC, R0
                add     #OFSTBL-., R0
                add     (R0), PC        ; и пойдём обрабатывать конкретную операцию
; ───────────────────────────────────────────────────────────────────────────
OFSTBL:         .word FADD$-OFSTBL      ; 75000
                .word FSUB$-OFSTBL      ; 75010
                .word FMUL$-OFSTBL      ; 75020
                .word FDIV$-OFSTBL      ; 75030
; ───────────────────────────────────────────────────────────────────────────
; деление A = A / B

FDIV$:          clr     -(SP)           ; флаг знака результата
                mov     R2, R0          ; сохраним порядок B
                bgt     2$              ; если больше 0 - переход туда
                blt     1$              ; если меньше 0 - переход туда
                jmp     FERR$           ; если равно 0 - ошибка, на 0 делить нельзя

1$:             inc     (SP)            ; отмечаем смену знака результата
2$:             mov     R4, R1          ; сохраним порядок A
                beq     F3$             ; если это 0, то результат деления == 0
                bpl     3$              ; если больше 0 - переход
                inc     (SP)            ; отмечаем смену знака результата
3$:             call    SEPAR           ; разделяем мантиссу и порядок
                sub     R0, R1          ; res.exp = A.exp - B.exp
                add     #37600, R1      ; подразумеваемый бит
                mov     R1, -(SP)       ; сохраняем
                mov     #100, R1        ; начальное значение, бит, по которому будет выход из цикла
                clr     R0
                br      5$              ; и идём просто делить R4:R5 на R2:R3

4$:             asl     R5
                rol     R4
5$:             sub     R3, R5
                sbc     R4
                sub     R2, R4
                bmi     8$

6$:             sec
                rol     R1
                rol     R0
                bcc     4$
                br      9$

7$:             asl     R5
                rol     R4
                add     R3, R5
                adc     R4
                add     R2, R4
                bpl     6$

8$:             clc
                rol     R1
                rol     R0
                bcc     7$
9$:             mov     R0, R2          ; вот результат
                mov     R1, R3          ; тут R1 == R3
                jmp     NRRT$           ; и по идее, R1 не нужен, при сдвиге вправо
; ───────────────────────────────────────────────────────────────────────────

F3$:            tst     (SP)+
                clr     R2
                clr     R3
                jmp     FL$NZ$          ; установка признаков N и Z
; ───────────────────────────────────────────────────────────────────────────
; умножение A = A * B

FMUL$:          clr     -(SP)           ; флаг знака
                mov     R2, R0          ; сохраним порядок B
                beq     F3$             ; если это 0, то результат умножения == 0
                bpl     1$              ; если > 0, то переход
                inc     (SP)            ; иначе результат будет отрицательный

1$:             mov     R4, R1          ; сохраним порядок A
                beq     F3$             ; если это 0, то результат умножения == 0
                bpl     2$              ; если > 0, то переход
                inc     (SP)            ; иначе результат будет отрицательный, или, если B было <0, то положительный

2$:             call    SEPAR           ; разделяем мантиссу и порядок
                add     R0, R1          ; res.exp = A.exp + B.exp
                sub     #40000, R1      ; подразумеваемый бит
                mov     R1, -(SP)       ; порядок результата
                mov     R5, -(SP)       ; A.m.lo ->
                mov     R4, -(SP)       ; A.m.hi ->
                mov     R3, -(SP)       ; B.m.lo ->
                mov     R4, R3          ; A.m.hi
                mov     R5, R4          ; A.m.lo
                mov     R2, R5          ; B.m.hi
                ; умножаем A.m на B.m.hi
                call    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                        ; на выходе в R5 нуль
                mov     R1, -(SP)       ; результат сохраним
                mov     R0, -(SP)
                mov     4(SP), R5       ; B.m.lo
                beq     3$              ; если 0, незачем умножать
                mov     6(SP), R4       ; А.m.hi
                clr     R3
                ; умножаем A.m.hi на B.m.lo
                call    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                        ; на выходе в R5 нуль
                add     R1, 2(SP)       ; складываем с предыдущем результатом
                adc     (SP)
                add     R0, (SP)
                mov     10(SP), R4      ; A.m.lo
                beq     3$              ; если 0, незачем умножать
                mov     4(SP), R5       ; B.m.lo
                clr     R3
                ; умножаем A.m.lo на B.m.lo
                call    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                        ; на выходе в R5 нуль
                add     R0, 2(SP)       ; складываем с предыдущем результатом
                adc     (SP)
                ; что-то не пойму логику.
                ; res = A.m * B.m.hi + (A.m.hi + A.m.lo) * B.m.lo

3$:             clr     R2
                bisb    1(SP), R2       ; берём старший байт ст слова результата
                mov     2(SP), R1       ; берём мл слово результата
                swab    R1              ; переставляем байты
                movb    (SP)+, (SP)     ; замещаем младший байт мл слова младшим байтом ст слова результата
                mov     (SP)+, R3       ; и достаём это
                swab    R3              ; переставляем байты
                                        ; в результате получается res = R2:R3:R1
                                        ; в старшем байте R2 - 0, в младшем байте R1 - незначащий мусор
                add     #6, SP          ; освобождаем стек
                jmp     NRLT$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; разделяем мантиссу и порядок

SEPAR:          bic     #100177, R0     ; выделяем порядок B (B.exp)
                bic     #100177, R1     ; выделяем порядок A (A.exp)
                bic     #177600, R2     ; выделяем мантиссу B (B.m)
                bic     #177600, R4     ; выделяем мантиссу A (A.m)
                bis     #200, R2        ; добавляем подразумеваемый бит в B.m
                bis     #200, R4        ; добавляем подразумеваемый бит в B.m
                return
; End of function SEPAR

; ───────────────────────────────────────────────────────────────────────────
; вычитание A = A - B - это A + (-B)

FSUB$:          tst     R2              ; B == 0 ?
; тут таки не учитывается, что если порядок 0, то в мантиссе может быть
; любой мусор, он должен просто игнорироваться.
                beq     FADD$           ; да, пойдём, прибавим 0
                add     #100000, R2     ; иначе, поменяем знак B = -B
; ───────────────────────────────────────────────────────────────────────────
; сложение A = A + B

FADD$:          mov     R2, R0          ; что мы там прибавляем?
                bne     1$              ; не ноль
                mov     R4, R2          ; а если 0, то просто
                mov     R5, R3          ; res = A
                br      FL$NZ$          ; установка признаков N и Z

1$:             mov     R4, R1          ; а если A == 0, то res = B
                beq     FL$NZ$          ; установка признаков N и Z
                bic     #177600, R2     ; оставляем в R2:R3 только мантиссу B (B.m)
                bis     #200, R2        ; добавляем подразумеваемый бит
                tst     R0              ; а число B какое?
                bpl     2$              ; положительное
                neg     R3              ; отрицательное - поменяем знак мантиссы
                adc     R2
                neg     R2
2$:             bic     #177600, R4     ; оставляем в R4:R5 только мантиссу A (A.m)
                bis     #200, R4        ; добавляем подразумеваемый бит
                tst     R1              ; а число A какое?
                bpl     3$              ; положительное
                neg     R5              ; отрицательное - поменяем знак мантиссы
                adc     R4
                neg     R4
3$:             bic     #100177, R0     ; это порядок B (B.exp)
                bic     #100177, R1     ; это порядок A (A.exp)
                clr     -(SP)           ; флаг знака
                mov     R0, -(SP)       ; B.exp
                sub     R1, R0          ; B.exp = B.exp - A.exp
                bhi     5$              ; если B.exp > A.exp
                blo     4$              ; если B.exp < A.exp
                ; если B.exp == A.exp
                clr     R1              ; B.exp = A.exp = 0
                br      8$

                ; B.exp < A.exp
4$:             mov     R1, (SP)        ; вместо B.exp поместим A.exp
                neg     R0              ; A.exp - B.exp
                mov     R2, R1          ; B.m <--> A.m
                mov     R4, R2          ; меняем местами мантиссы A и B
                mov     R1, R4
                mov     R3, R1
                mov     R5, R3
                mov     R1, R5
                ; B.exp > A.exp
5$:             clr     R1              ; tmp = 0 (вытесненные биты из выровненной мантиссы)
                cmp     R0, #6000
                ble     6$              ; B.exp - A.exp <= 24.
                clr     R4              ; если больше, то A.m = 0
                clr     R5
                br      8$

                ; B.exp - A.exp <= 24.
6$:             asl     R0
                swab    R0              ; разность B.exp - A.exp в мл байт
                ; выравниваем мантиссы в соответствии с порядками.
7$:             asr     R4              ; и двигаем A.m вправо
                ror     R5
                ror     R1              ; а сюда принимаем биты
                sob     R0, 7$

8$:             add     R5, R3          ; res.m = B.m + A.m
                adc     R2
                add     R4, R2
                bpl     9$              ; если >= 0, переход
                neg     R1              ; иначе меняем знак
                adc     R3
                adc     R2
                neg     R3
                adc     R2
                neg     R2
                inc     2(SP)           ; и фиксируем этот факт
9$:             mov     R3, R4          ; проверяем, что получилось
                bis     R1, R4
                bis     R2, R4
                bne     NRRT$           ; что-то получилось - переход
                cmp     (SP)+, (SP)+    ; все нули, освобождаем стек
                br      FL$NZ$          ; установка признаков N и Z
; ───────────────────────────────────────────────────────────────────────────
; сдвигаем мантиссу вправо

NRRT$:          cmp     R2, #400        ; res.hi умещается в мл байт?
                blo     NRLT$           ; да
                asr     R2              ; нет, двигаем вправо
                ror     R3
                ror     R1
                add     #200, (SP)       ; считаем кол-во сдвигов (это добавка к порядку)
                br      NRRT$           ; и так пока не станет умещаться.
; ───────────────────────────────────────────────────────────────────────────
; сдвигаем мантиссу влево

NRLT$:          tstb    R2              ; старший бит мантиссы == 1 ?
                bmi     2$              ; да
1$:             sub     #200, (SP)      ; нет - считаем кол-во сдвигов
                asl     R1              ; двигаем влево
                rol     R3
                rolb    R2
                bpl     1$              ; и так, пока старший бит мантиссы не станет 1

2$:             asl     R1              ; округляем до двухсловного числа
                adc     R3
                adcb    R2
                bcc     3$              ; переполнения не случилось?
                add     #200, (SP)      ; случилось - скорректируем порядок.

3$:             mov     (SP)+, R4       ; достаём порядок из стека
                ; ОШИБКА!!! пропущена команда BEQ F5$
                bpl     4$        ; если >=0, то переход
                clr     R5              ; а иначе - переполнение  ОШИБКА!!! эта команда должна быть перед извлечением R4 из стека
                rol     R4              ; двигаем порядок влево
                bpl     F6$             ; если стало >=0, то V
                br      F5$             ; иначе N и V
; по идее, тут ещё и C должно формироваться, если С==1, но нет.
; Из-за этих ошибок не проходит тест 791403, потому что с флагами творится полная чушь

4$:             ror     (SP)+           ; достаём знак результата
                bcc     5$              ; если +, то переход
                bis     #100000, R2     ; если -, то формируем знаковый бит
5$:             bic     #200, R2        ; очищаем подразумеваемый бит мантиссы
                bis     R4, R2          ; помещаем порядок на место
; ───────────────────────────────────────────────────────────────────────────
; установка признаков N и Z

FL$NZ$:         clr     R5              ; тут формируются признаки
                tst     R2              ; res.hi == 0 ?
                bne     1$              ; нет
                bis     #4, R5          ; да - формируем Z

1$:             bpl     2$              ; res.hi >= 0 или просто переход после bis
                bis     #10, R5         ; res.hi < 0 - формируем N

2$:             mov     (SP)+, R1       ; конец блока параметров
                mov     (SP)+, R0       ; адрес в стеке, где хранится значение используемого регистра
                mov     R3, -(R1)       ; сохраняем res на место A
                mov     R2, -(R1)
                mov     R1, (R0)        ; а адрес res - в регистр
                sub     SP, R0          ; а теперь проверим, какой это был регистр
                cmp     R0, #14
                blo     3$              ; если это R0-R5, то всё как обычно
                beq     4$              ; если это SP
                add     #4, 16(SP)      ; если это PC - то он должен указывать за res,
                                        ; а не на него, как все остальные регистры

3$:             call    RSTRS$          ; установка признаков и восстановление регистров
                rti

4$:             call    RSTRS$          ; установка признаков и восстановление регистров
                mov     (SP)+, 2(SP)    ; переместим PS/PC в стеке на место B,
                mov     (SP)+, 2(SP)    ; оно всё равно не нужно
                rti                     ; и выходим. Изящно получается со стеком в качестве буфера
; ───────────────────────────────────────────────────────────────────────────

FERR$:          bis     #1, R5          ; формируем C     ОШИБКА!!! должно быть MOV #1,R5
F5$:            bis     #10, R5         ; формируем N
F6$:            bis     #2, R5          ; формируем V
                cmp     (SP)+, (SP)+    ; убираем из стека флаг знака и конец блока параметров FIS
                mov     (SP)+, R0       ; достаём адрес в стеке, где хранится значение используемого регистра
                sub     SP, R0          ; проверим, какой это был регистр
                cmp     R0, #16         ; это PC?
                bne     1$              ; нет
                add     #10, 16(SP)     ; да - передвинем его за блок параметров
1$:             call    RSTRS$          ; установка признаков и восстановление регистров
                mov     @#246, -(SP)    ; эмулируем возникновение прерывания по ошибке
                mov     @#244, -(SP)    ; СППЗ
                rti                     ; если кто об этом не знал, ему же хуже.
; ───────────────────────────────────────────────────────────────────────────

EXTAR$:         cmp     R0, #70000      ; точно EIS?
                bhis    1$              ; да
                jmp     ERRCM$          ; нет - другие не эмулируемые опкоды

1$:             bic     #170777, R0     ; выделим код опкода
                swab    R0              ; вот он уже умноженный на 2
                mov     R1, R2
                bic     #177770, R1     ; выделим регистр источника
                rol     R1              ; *2
                asr     R2
                asr     R2
                mov     R2, R3
                bic     #177761, R2     ; выделим код адресации источника *2
                asr     R3
                asr     R3
                asr     R3
                bic     #177761, R3     ; выделим регистр приёмника *2
                mov     #2, R4
                bis     R3, R4          ; а это R+1 приёмника
                add     SP, R3          ; находим адрес в стеке, где находится содержимое регистров приёмника
                add     SP, R4
                mov     R1, -(SP)       ; регистр источника сохраним
                add     SP, R1          ; находим адрес в стеке, где находится содержимое регистра источника
                add     #2, R1
                mov     R2, -(SP)       ; адресацию источника в стек
                add     PC, (SP)        ; и сформируем там адрес перехода
                add     #6, (SP)        ; а при этом у нас R5 свободен
                add     @(SP)+, PC      ; зачем надо было стек использовать, непонятно
; ───────────────────────────────────────────────────────────────────────────
EPCBS2:         .word ADDR01-EPCBS2     ; 0 Rx
                .word ADDR01-EPCBS2     ; 1 (Rx)
                .word ADDR23-EPCBS2     ; 2 (Rx)+
                .word ADDR23-EPCBS2     ; 3 @(Rx)+
                .word ADDR45-EPCBS2     ; 4 -(Rx)
                .word ADDR45-EPCBS2     ; 5 @-(Rx)
                .word ADDR67-EPCBS2     ; 6 n(Rx)
                .word ADDR67-EPCBS2     ; 7 @n(Rx)
; ───────────────────────────────────────────────────────────────────────────
; автоинкрементная адресация

ADDR23:         inc     (SP)            ; номер регистра источника ++ - признак автоинкрементной адресации
                mov     (R1), R5        ; берём содержимое регистра источника
                add     #2, (R1)        ; инкрементируем
                br      ARROP$
; ───────────────────────────────────────────────────────────────────────────
; автодекрементная адресация

ADDR45:         sub     #2, (R1)        ; декрементируем
                mov     (R1), R5        ; берём содержимое регистра источника
                br      ARROP$
; ───────────────────────────────────────────────────────────────────────────
; индексная адресация

ADDR67:         mov     @20(SP), R5     ; берём индекс по содержимому PC
                add     #2, 20(SP)      ; прибавляем к содержимому PC два
                add     (R1), R5        ; прибавляем к индексу содержимое регистра источника
                br      ARROP$
; ───────────────────────────────────────────────────────────────────────────
; регистровая адресация

ADDR01:         mov     R1, R5          ; берём регистр источник
ARROP$:         bit     #2, R2          ; адресация относительная?
                beq     1$              ; нет
                mov     (R5), R5        ; да - значит получим значение по адресу значения
1$:             mov     R4, -(SP)       ; R+1 приёмника
                mov     R3, -(SP)       ; R приёмника
                add     PC, R0
                add     #OFSTB2-., R0
                add     (R0), PC
; ───────────────────────────────────────────────────────────────────────────
OFSTB2:         .word MUL$-OFSTB2       ; 70000
                .word DIV$-OFSTB2       ; 71000
                .word ASH$-OFSTB2       ; 72000
                .word ASHC$-OFSTB2      ; 73000
                .word XOR$-OFSTB2       ; 74000
; ───────────────────────────────────────────────────────────────────────────
; умножение R:R+1 = R * ss

MUL$:           mov     (R3), R4        ; берём мл. часть
                beq     3$              ; если 0, то результат 0
                mov     (R5), R5        ; берём источник
                beq     3$              ; если 0, то результат 0
                bpl     1$              ; если >= 0, то идём умножать
                neg     R4              ; иначе R4 = -R4
                neg     R5              ; R5 = -R5
                bpl     1$              ; если >= 0, то идём умножать
                                        ; иначе в R5 число 100000
                mov     R4, R3          ; R4 <-> R5
                mov     R5, R4
                mov     R3, R5
                bpl     1$              ; если >= 0, то идём умножать
                neg     R5              ; иначе R5 = -R5
                bmi     4$              ; если < 0, то и в R4 тоже было число 100000

1$:             tst     R4              ; умножаем
                sxt     R3
                call    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                        ; на выходе в R5 нуль
                tst     R1              ; посмотрим
                sxt     R2              ; какой знак у мл. части
                cmp     R0, R2          ; если знак распространён на ст. часть
                beq     2$              ; то всё нормально
                bis     #1, R5          ; иначе бит C

2$:             jmp     EARX1$          ; выходим

3$:             clr     R0              ; результат
                clr     R1
                clr     R5              ; флаги
                jmp     EARX1$          ; выходим

4$:             mov     #40000, R0      ; результат умножения 100000 * 100000
                clr     R1
                clr     R5
                br      2$
; ───────────────────────────────────────────────────────────────────────────
; деление R = R:R+1 / ss , R+1 = R:R+1 % ss

DIV$:           clr     -(SP)           ; флаг знака результата
                mov     (R3), R0        ; значение R приёмника
                mov     (R4), R1        ; значение R+1 приёмника
                mov     R0, -(SP)
                bpl     1$
                inc     2(SP)
                neg     R1
                adc     R0
                neg     R0
                bmi     14$

1$:             mov     (R5), R4
                beq     13$
                bpl     2$
                inc     2(SP)
                neg     R4
                bmi     14$

2$:             clr     R5
                cmp     R0, R4
                bgt     14$
                blt     3$
                cmp     R1, R4
                bhis    14$

3$:             clr     R2
                mov     #20, R3
4$:             asr     R4
                ror     R5
                sub     R5, R1
                sbc     R0
                sub     R4, R0
                bmi     7$

5$:             sec
                rol     R2
                sob     R3, 4$
                br      8$

6$:             asr     R4
                ror     R5
                add     R5, R1
                adc     R0
                add     R4, R0
                bpl     5$

7$:             clc
                rol     R2
                sob     R3, 6$
                add     R5, R1

8$:             tst     (SP)+
                bpl     9$
                neg     R1

9$:             asr     (SP)+
                bcc     10$
                neg     R2

10$:            clr     R5
                mov     R2, R0
                bpl     11$
                bis     #10, R5         ; N

11$:            bne     12$
                bis     #4, R5          ; Z

12$:            jmp     EARX2$

13$:            mov     #3, R5          ; флаги VC
                br      15$

14$:            mov     #2, R5          ; переполнение V
15$:            add     #10, SP         ; результат не сохраняется
                jmp     EARX3$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; получаем R и число битов для сдвигаем
; выход: R2 = 0
;        R0 = R
;        R5 = счётчик сдвигов
;        Z - в счётчике 0
;        С - сдвиг вправо

SRCASH:         clr     R2
                mov     (R3), R0        ; значение R приёмника
                mov     (R5), R5        ; значение источника
                bit     #40, R5         ; смотрим знак
                beq     1$              ; +
                bis     #177700, R5     ; - , устанавливаем биты
                neg     R5              ; и меняем знак
                return

1$:             bic     #177700, R5     ; очищаем биты
                return
; End of function SRCASH

; ───────────────────────────────────────────────────────────────────────────
; арифметический сдвиг R = R << ss / R = R >> ss

ASH$:           mov     R3, 2(SP)       ; R+1 заменяем на R
                call    SRCASH          ; получаем R и число битов для сдвигаем
                                        ; выход: R2 = 0
                                        ;        R0 = R
                                        ;        R5 = счётчик сдвигов
                                        ;        Z - в счётчике 0
                                        ;        С - сдвиг вправо
                beq     4$              ; 0, не надо ничего двигать
                bcs     3$              ; двигать вправо

1$:             asl     R0              ; двигаем влево
                bvc     2$
                inc     R2              ; а тут отмечаем возникновение бита V

2$:             sob     R5, 1$          ; на заданное количество бит
                br      4$

3$:             asr     R0              ; двигаем вправо, тут переполнения не бывает
                sob     R5, 3$          ; на заданное количество бит

4$:             mov     R0, R1          ; результат дублируем и для R+1
                br      EARX4$
; ───────────────────────────────────────────────────────────────────────────
; арифметический сдвиг R:R+1 = R:R+1 << ss / R:R+1 = R:R+1 >> ss

ASHC$:          mov     (R4), R1        ; значение R+1 приёмника
                call    SRCASH          ; получаем R и число битов для сдвигаем
                                        ; выход: R2 = 0
                                        ;        R0 = R
                                        ;        R5 = счётчик сдвигов
                                        ;        Z - в счётчике 0
                                        ;        С - сдвиг вправо
                beq     EARX4$          ; 0, не надо ничего двигать
                bcs     3$              ; двигать вправо

1$:             asl     R1              ; двигаем влево
                rol     R0
                bvc     2$
                inc     R2              ; а тут отмечаем возникновение бита V

2$:             sob     R5, 1$          ; на заданное количество бит
                br      EARX4$

3$:             asr     R0              ; двигаем вправо, тут переполнения не бывает
                ror     R1
                sob     R5, 3$          ; на заданное количество бит
                br      EARX4$
; ───────────────────────────────────────────────────────────────────────────
; операция исключающее или.
; dd = dd xor R

XOR$:           cmp     (SP)+, (SP)+    ; типа игнорируется? могли бы и заэмулировать. это не так и трудно
                br      EARX3$
; ───────────────────────────────────────────────────────────────────────────
; вход только для ASH/ASHC
; вход: R0:R1 - результат
;       R5 - флаги
;       R2 - признак возникновения переполнения V

EARX4$:         adc     R5              ; ставим флаг C, если было
                tst     R2
                beq     EARX1$
                bis     #2, R5          ; ставим флаг V
; ───────────────────────────────────────────────────────────────────────────
; вход: R0:R1 - результат
;       R5 - флаги

EARX1$:         tst     R0              ; смотрим знак результата
                bpl     1$        ; >= 0
                bis     #10, R5         ; < 0 - ставим флаг N
1$:             bne     EARX2$          ; идём туда
                tst     R1
                bne     EARX2$
                bis     #4, R5          ; если R0:R1 == 0, ставим флаг Z
EARX2$:         mov     R0, @(SP)+      ; ст часть в R
                mov     R1, @(SP)+      ; мл часть в R+1
EARX3$:         cmp     (SP)+, #15      ; если регистр источник был SP и адресация была автоинкрементная
                beq     2$              ; то переход
                call    RSTRS$          ; установка признаков и восстановление регистров
                rti                     ; и выходим

2$:             call    RSTRS$          ; установка признаков и восстановление регистров
                ; для автоинкрементной адресации со стеком, аргумент источника был в стеке, поэтому
                mov     2(SP), 4(SP)    ; сдвинем PS/PC на место аргумента
                mov     (SP)+, (SP)     ; сделаем освобождение стека от аргумента
                rti                     ; и выходим
FISDataEnd$:

                .end
